/* ***************************************************************************
   *                                                                         *
   *   Kindermann                        Wahlpflichtkurs Produktentwicklung  *
   *                                     Schuljahr: 2014-15                  *
   *                                                                         *
   *                             AVR-Flashtool 1.6                           *
   *                                                                         *
   *                         (Crossplattform-Version)                        *
   *                                                                         *
   ***************************************************************************/


#ifndef _H_CPAGE_
#define _H_CPAGE_

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#include "communicate.h"

class CPage {
 public:
  CPage(unsigned int pageaddress, unsigned int pagesize);
  ~CPage();

  unsigned int getPageaddress();
  unsigned int getPagesize(Communicate* comm);
  unsigned char* getData();
  CPage* getPrev();
  CPage* getNext();
  CPage* insert(unsigned int nAddress, unsigned char bValue);
  void display(Communicate* comm);
  void setPrev(CPage* pPage);
  void setNext(CPage* pPage);

 protected:
  int m_nPageaddress;
  int m_nPagesize;
  unsigned char * m_pData;
  CPage* m_pPrevpage;
  CPage* m_pNextpage;
};

#endif
